Index: LMDZ4/trunk/libf/phylmd/calcul_STDlev.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/calcul_STDlev.h	(revision 644)
+++ LMDZ4/trunk/libf/phylmd/calcul_STDlev.h	(revision 684)
@@ -6,50 +6,50 @@
 c
         CALL ini_undefSTD(nlevSTD,itap,
-     $           ecrit_day,ecrit_mth,
+     $           dtime,ecrit_day,ecrit_mth,
      $                    tnondef,tsumSTD)
         CALL ini_undefSTD(nlevSTD,itap,
-     $           ecrit_day,ecrit_mth,
+     $           dtime,ecrit_day,ecrit_mth,
      $                    tnondef,usumSTD)
         CALL ini_undefSTD(nlevSTD,itap,
-     $           ecrit_day,ecrit_mth,
+     $           dtime,ecrit_day,ecrit_mth,
      $                    tnondef,vsumSTD)
         CALL ini_undefSTD(nlevSTD,itap,
-     $           ecrit_day,ecrit_mth,
+     $           dtime,ecrit_day,ecrit_mth,
      $                    tnondef,wsumSTD)
         CALL ini_undefSTD(nlevSTD,itap,
-     $           ecrit_day,ecrit_mth,
+     $           dtime,ecrit_day,ecrit_mth,
      $                    tnondef,phisumSTD)
         CALL ini_undefSTD(nlevSTD,itap,
-     $           ecrit_day,ecrit_mth,
+     $           dtime,ecrit_day,ecrit_mth,
      $                    tnondef,qsumSTD)
         CALL ini_undefSTD(nlevSTD,itap,
-     $           ecrit_day,ecrit_mth,
+     $           dtime,ecrit_day,ecrit_mth,
      $                    tnondef,rhsumSTD)
         CALL ini_undefSTD(nlevSTD,itap,
-     $           ecrit_day,ecrit_mth,
+     $           dtime,ecrit_day,ecrit_mth,
      $                    tnondef,uvsumSTD)
         CALL ini_undefSTD(nlevSTD,itap,
-     $           ecrit_day,ecrit_mth,
+     $           dtime,ecrit_day,ecrit_mth,
      $                    tnondef,vqsumSTD)
         CALL ini_undefSTD(nlevSTD,itap,
-     $           ecrit_day,ecrit_mth,
+     $           dtime,ecrit_day,ecrit_mth,
      $                    tnondef,vTsumSTD)
         CALL ini_undefSTD(nlevSTD,itap,
-     $           ecrit_day,ecrit_mth,
+     $           dtime,ecrit_day,ecrit_mth,
      $                    tnondef,wqsumSTD)
         CALL ini_undefSTD(nlevSTD,itap,
-     $           ecrit_day,ecrit_mth,
+     $           dtime,ecrit_day,ecrit_mth,
      $                    tnondef,vphisumSTD)
         CALL ini_undefSTD(nlevSTD,itap,
-     $           ecrit_day,ecrit_mth,
+     $           dtime,ecrit_day,ecrit_mth,
      $                    tnondef,wTsumSTD)
         CALL ini_undefSTD(nlevSTD,itap,
-     $           ecrit_day,ecrit_mth,
+     $           dtime,ecrit_day,ecrit_mth,
      $                    tnondef,u2sumSTD)
         CALL ini_undefSTD(nlevSTD,itap,
-     $           ecrit_day,ecrit_mth,
+     $           dtime,ecrit_day,ecrit_mth,
      $                    tnondef,v2sumSTD)
         CALL ini_undefSTD(nlevSTD,itap,
-     $           ecrit_day,ecrit_mth,
+     $           dtime,ecrit_day,ecrit_mth,
      $                    tnondef,T2sumSTD)
 c
@@ -159,80 +159,80 @@
        oknondef(1:klon,1:nlevSTD,1:nout)=.TRUE.
        CALL undefSTD(nlevSTD,itap,tlevSTD,
-     $               ecrit_hf,
+     $               dtime,ecrit_hf,
      $               oknondef,tnondef,tsumSTD)
 c
        oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
        CALL undefSTD(nlevSTD,itap,ulevSTD,
-     $           ecrit_hf,
+     $           dtime,ecrit_hf,
      $               oknondef,tnondef,usumSTD)
 c
        oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
        CALL undefSTD(nlevSTD,itap,vlevSTD,
-     $           ecrit_hf,
+     $           dtime,ecrit_hf,
      $               oknondef,tnondef,vsumSTD)
 c
        oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
        CALL undefSTD(nlevSTD,itap,wlevSTD,
-     $           ecrit_hf,
+     $           dtime,ecrit_hf,
      $               oknondef,tnondef,wsumSTD)
 c
        oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
        CALL undefSTD(nlevSTD,itap,philevSTD,
-     $           ecrit_hf,
+     $           dtime,ecrit_hf,
      $               oknondef,tnondef,phisumSTD)
 c
        oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
        CALL undefSTD(nlevSTD,itap,qlevSTD,
-     $           ecrit_hf,
+     $           dtime,ecrit_hf,
      $               oknondef,tnondef,qsumSTD)
 c
        oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
        CALL undefSTD(nlevSTD,itap,rhlevSTD,
-     $           ecrit_hf,
+     $           dtime,ecrit_hf,
      $               oknondef,tnondef,rhsumSTD)
 c
        oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
        CALL undefSTD(nlevSTD,itap,uvSTD,
-     $           ecrit_hf,
+     $           dtime,ecrit_hf,
      $               oknondef,tnondef,uvsumSTD)
 c
        oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
        CALL undefSTD(nlevSTD,itap,vqSTD,
-     $           ecrit_hf,
+     $           dtime,ecrit_hf,
      $               oknondef,tnondef,vqsumSTD)
 c
        oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
        CALL undefSTD(nlevSTD,itap,vTSTD,
-     $           ecrit_hf,
+     $           dtime,ecrit_hf,
      $               oknondef,tnondef,vTsumSTD)
 c
        oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
        CALL undefSTD(nlevSTD,itap,wqSTD,
-     $           ecrit_hf,
+     $           dtime,ecrit_hf,
      $               oknondef,tnondef,wqsumSTD)
 c
        oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
        CALL undefSTD(nlevSTD,itap,vphiSTD,
-     $           ecrit_hf,
+     $           dtime,ecrit_hf,
      $               oknondef,tnondef,vphisumSTD)
 c
        oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
        CALL undefSTD(nlevSTD,itap,wTSTD,
-     $           ecrit_hf,
+     $           dtime,ecrit_hf,
      $               oknondef,tnondef,wTsumSTD)
 c
        oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
        CALL undefSTD(nlevSTD,itap,u2STD,
-     $           ecrit_hf,
+     $           dtime,ecrit_hf,
      $               oknondef,tnondef,u2sumSTD)
 c
        oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
        CALL undefSTD(nlevSTD,itap,v2STD,
-     $           ecrit_hf,
+     $           dtime,ecrit_hf,
      $               oknondef,tnondef,v2sumSTD)
 c
        oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
        CALL undefSTD(nlevSTD,itap,T2STD,
-     $           ecrit_hf,
+     $           dtime,ecrit_hf,
      $               oknondef,tnondef,T2sumSTD)
 c
@@ -240,65 +240,65 @@
 c
        CALL moy_undefSTD(nlevSTD,itap,
-     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $      dtime,ecrit_day,ecrit_mth,ecrit_hf2mth,
      $                   tnondef,tsumSTD)
 c
        CALL moy_undefSTD(nlevSTD,itap,
-     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $      dtime,ecrit_day,ecrit_mth,ecrit_hf2mth,
      $                   tnondef,usumSTD)
 c
        CALL moy_undefSTD(nlevSTD,itap,
-     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $      dtime,ecrit_day,ecrit_mth,ecrit_hf2mth,
      $                   tnondef,vsumSTD)
 c
        CALL moy_undefSTD(nlevSTD,itap,
-     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $      dtime,ecrit_day,ecrit_mth,ecrit_hf2mth,
      $                   tnondef,wsumSTD)
 c
        CALL moy_undefSTD(nlevSTD,itap,
-     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $      dtime,ecrit_day,ecrit_mth,ecrit_hf2mth,
      $                   tnondef,phisumSTD)
 c
        CALL moy_undefSTD(nlevSTD,itap,
-     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $      dtime,ecrit_day,ecrit_mth,ecrit_hf2mth,
      $                   tnondef,qsumSTD)
 c
        CALL moy_undefSTD(nlevSTD,itap,
-     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $      dtime,ecrit_day,ecrit_mth,ecrit_hf2mth,
      $                   tnondef,rhsumSTD)
 c
        CALL moy_undefSTD(nlevSTD,itap,
-     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $      dtime,ecrit_day,ecrit_mth,ecrit_hf2mth,
      $                   tnondef,uvsumSTD)
 c
        CALL moy_undefSTD(nlevSTD,itap,
-     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $      dtime,ecrit_day,ecrit_mth,ecrit_hf2mth,
      $                   tnondef,vqsumSTD)
 c
        CALL moy_undefSTD(nlevSTD,itap,
-     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $      dtime,ecrit_day,ecrit_mth,ecrit_hf2mth,
      $                   tnondef,vTsumSTD)
 c
        CALL moy_undefSTD(nlevSTD,itap,
-     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $      dtime,ecrit_day,ecrit_mth,ecrit_hf2mth,
      $                   tnondef,wqsumSTD)
 c
        CALL moy_undefSTD(nlevSTD,itap,
-     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $      dtime,ecrit_day,ecrit_mth,ecrit_hf2mth,
      $                   tnondef,vphisumSTD)
 c
        CALL moy_undefSTD(nlevSTD,itap,
-     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $      dtime,ecrit_day,ecrit_mth,ecrit_hf2mth,
      $                   tnondef,wTsumSTD)
 c
        CALL moy_undefSTD(nlevSTD,itap,
-     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $      dtime,ecrit_day,ecrit_mth,ecrit_hf2mth,
      $                   tnondef,u2sumSTD)
 c
        CALL moy_undefSTD(nlevSTD,itap,
-     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $      dtime,ecrit_day,ecrit_mth,ecrit_hf2mth,
      $                   tnondef,v2sumSTD)
 c
        CALL moy_undefSTD(nlevSTD,itap,
-     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $      dtime,ecrit_day,ecrit_mth,ecrit_hf2mth,
      $                   tnondef,T2sumSTD)
 c