Index: /LMDZ4/trunk/libf/phylmd/physiq.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 693)
+++ /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 694)
@@ -42,6 +42,6 @@
 #define histmth
 #define histins
-c #define histISCCP
-c #define histmthNMC
+#define histmthNMC
+#define histISCCP
 c======================================================================
 c    modif   ( P. Le Van ,  12/10/98 )
@@ -1152,4 +1152,8 @@
       REAL zx_tmp_fi2d(klon)      ! variable temporaire grille physique
       REAL zx_tmp_fi3d(klon,klev) ! variable temporaire pour champs 3D 
+#ifdef histmthNMC
+      REAL zx_tmp_NC(iim,jjmp1,nlevSTD)
+      REAL zx_tmp_fiNC(klon,nlevSTD) 
+#endif
       REAL*8 zx_tmp2_fi3d(klon,klev) ! variable temporaire pour champs 3D 
       REAL zx_tmp_2d(iim,jjmp1), zx_tmp_3d(iim,jjmp1,klev)
Index: /LMDZ4/trunk/libf/phylmd/write_histmthNMC.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/write_histmthNMC.h	(revision 693)
+++ /LMDZ4/trunk/libf/phylmd/write_histmthNMC.h	(revision 694)
@@ -14,31 +14,31 @@
 ccc
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,tsumSTD(:,:,2),
-     $      zx_tmp_3d)
-       CALL histwrite(nid_nmc,"temp",itau_w,zx_tmp_3d,
+     $      zx_tmp_NC)
+       CALL histwrite(nid_nmc,"temp",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,phisumSTD(:,:,2),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"phi",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"phi",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,qsumSTD(:,:,2),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"q",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"q",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,rhsumSTD(:,:,2),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"rh",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"rh",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,usumSTD(:,:,2),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"u",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"u",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,vsumSTD(:,:,2),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"v",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"v",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 ccc
@@ -46,36 +46,36 @@
 ccc
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,tsumSTD(:,:,3),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"temp",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"temp",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,phisumSTD(:,:,3),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"phi",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"phi",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,qsumSTD(:,:,3),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"q",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"q",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,rhsumSTD(:,:,3),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"rh",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"rh",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,usumSTD(:,:,3),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"u",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"u",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,vsumSTD(:,:,3),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"v",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"v",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,wsumSTD(:,:,3),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"w",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"w",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
@@ -83,58 +83,58 @@
         DO i=1, klon
          IF(tnondef(i,k,3).NE.1.E+20) THEN
-          zx_tmp_fi3d(i,k) = (100.*tnondef(i,k,3))/ecrit_hf2mth
+          zx_tmp_fiNC(i,k) = (100.*tnondef(i,k,3))/ecrit_hf2mth
          ELSE
-          zx_tmp_fi3d(i,k) = 1.E+20
+          zx_tmp_fiNC(i,k) = 1.E+20
          ENDIF
         ENDDO
        ENDDO !k=1, nlevSTD
 c
-       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-       CALL histwrite(nid_nmc,"psbg",itau_w,zx_tmp_3d,
+       CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,zx_tmp_fiNC,zx_tmp_NC)
+       CALL histwrite(nid_nmc,"psbg",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,uvsumSTD(:,:,3),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"uv",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"uv",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,vqsumSTD(:,:,3),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"vq",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"vq",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,vTsumSTD(:,:,3),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"vT",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"vT",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1, wqsumSTD(:,:,3),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"wq",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"wq",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,vphisumSTD(:,:,3),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"vphi",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"vphi",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,wTsumSTD(:,:,3),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"wT",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"wT",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,u2sumSTD(:,:,3),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"uxu",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"uxu",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,v2sumSTD(:,:,3),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"vxv",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"vxv",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c
        CALL gr_fi_ecrit(nlevSTD, klon,iim,jjmp1,T2sumSTD(:,:,3),
-     $     zx_tmp_3d)
-       CALL histwrite(nid_nmc,"TxT",itau_w,zx_tmp_3d,
+     $     zx_tmp_NC)
+       CALL histwrite(nid_nmc,"TxT",itau_w,zx_tmp_NC,
      $       iim*jjmp1*nlevSTD,ndex3d)
 c