Index: LMDZ4/branches/V3_test/libf/phylmd/conf_phys.F90
===================================================================
--- LMDZ4/branches/V3_test/libf/phylmd/conf_phys.F90	(revision 703)
+++ LMDZ4/branches/V3_test/libf/phylmd/conf_phys.F90	(revision 704)
@@ -23,5 +23,5 @@
 include "clesphys.inc"
 include "compbl.h"
-#include "control.inc"
+include "control.inc"
 !
 ! Configuration de la "physique" de LMDZ a l'aide de la fonction
@@ -49,6 +49,14 @@
   REAL                 :: bl95_b0, bl95_b1
   real                 :: fact_cldcon, facttemps,ratqsbas,ratqshaut
-!IM integer            :: iflag_cldcon, if_ebil
   integer              :: iflag_cldcon
+
+  character (len = 6),SAVE  :: ocean_omp
+  logical,SAVE              :: ok_veget_omp, ok_newmicro_omp
+  logical,SAVE        :: ok_journe_omp, ok_mensuel_omp, ok_instan_omp        
+  LOGICAL,SAVE        :: ok_ade_omp, ok_aie_omp
+  REAL,SAVE           :: bl95_b0_omp, bl95_b1_omp
+  real,SAVE           :: fact_cldcon_omp, facttemps_omp,ratqsbas_omp
+  real,SAVE           :: ratqshaut_omp
+  integer,SAVE        :: iflag_cldcon_omp, ip_ebil_phy_omp
 
 ! Local
@@ -57,9 +65,33 @@
 
   integer :: iflag_thermals,nsplit_thermals
-!
-!
-!
-
-
+  integer,SAVE :: iflag_thermals_omp,nsplit_thermals_omp
+
+  REAL,SAVE :: R_ecc_omp,R_peri_omp,R_incl_omp,solaire_omp,co2_ppm_omp
+  REAL,SAVE :: RCO2_omp,CH4_ppb_omp,RCH4_omp,N2O_ppb_omp,RN2O_omp,CFC11_ppt_omp
+  REAL,SAVE :: RCFC11_omp,CFC12_ppt_omp,RCFC12_omp,epmax_omp
+  LOGICAL,SAVE :: ok_adj_ema_omp
+  INTEGER,SAVE :: iflag_clw_omp
+  REAL,SAVE :: cld_lc_lsc_omp,cld_lc_con_omp,cld_tau_lsc_omp,cld_tau_con_omp
+  REAL,SAVE :: ffallv_lsc_omp, ffallv_con_omp,coef_eva_omp
+  LOGICAL,SAVE :: reevap_ice_omp
+  INTEGER,SAVE :: iflag_pdf_omp
+  REAL,SAVE :: rad_froid_omp, rad_chau1_omp, rad_chau2_omp
+  INTEGER,SAVE :: top_height_omp,overlap_omp
+  REAL,SAVE :: cdmmax_omp,cdhmax_omp,ksta_omp,ksta_ter_omp
+  LOGICAL,SAVE :: ok_kzmin_omp
+  INTEGER,SAVE :: iflag_pbl_omp,lev_histhf_omp,lev_histday_omp,lev_histmth_omp
+  CHARACTER*4, SAVE :: type_run_omp
+  LOGICAL,SAVE :: ok_isccp_omp
+  REAL,SAVE :: lonmin_ins_omp, lonmax_ins_omp, latmin_ins_omp, latmax_ins_omp
+  REAL,SAVE :: ecrit_hf_omp, ecrit_day_omp, ecrit_mth_omp, ecrit_reg_omp
+  REAL,SAVE :: ecrit_tra_omp
+  LOGICAL, SAVE :: ok_slab_sicOBS_omp
+  REAL,SAVE :: cvl_corr_omp
+  LOGICAL,SAVE :: ok_lic_melt_omp
+!
+!
+!
+
+!$OMP MASTER
 !Config Key  = OCEAN 
 !Config Desc = Type d'ocean
@@ -67,6 +99,6 @@
 !Config Help = Type d'ocean utilise: force, slab,couple
 !
-  ocean = 'force '
-  call getin('OCEAN', ocean)
+  ocean_omp = 'force '
+  call getin('OCEAN', ocean_omp)
 !
 !Config Key  = VEGET 
@@ -75,6 +107,6 @@
 !Config Help = Type de modele de vegetation utilise
 !
-  ok_veget = .false.
-  call getin('VEGET', ok_veget)
+  ok_veget_omp = .false.
+  call getin('VEGET', ok_veget_omp)
 !
 !Config Key  = OK_journe
@@ -84,6 +116,6 @@
 !              journalieres 
 !
-  ok_journe = .false.
-  call getin('OK_journe', ok_journe)
+  ok_journe_omp = .false.
+  call getin('OK_journe', ok_journe_omp)
 !
 !Config Key  = OK_mensuel
@@ -93,6 +125,6 @@
 !              mensuelles 
 !
-  ok_mensuel = .true.
-  call getin('OK_mensuel', ok_mensuel)
+  ok_mensuel_omp = .true.
+  call getin('OK_mensuel', ok_mensuel_omp)
 !
 !Config Key  = OK_instan
@@ -102,6 +134,6 @@
 !              instantanees 
 !
-  ok_instan = .false.
-  call getin('OK_instan', ok_instan)
+  ok_instan_omp = .false.
+  call getin('OK_instan', ok_instan_omp)
 !
 !Config Key  = ok_ade
@@ -110,6 +142,6 @@
 !Config Help = Used in radlwsw.F
 !
-  ok_ade = .false.
-  call getin('ok_ade', ok_ade)
+  ok_ade_omp = .false.
+  call getin('ok_ade', ok_ade_omp)
 
 !
@@ -119,6 +151,6 @@
 !Config Help = Used in nuage.F and radlwsw.F
 !
-  ok_aie = .false.
-  call getin('ok_aie', ok_aie)
+  ok_aie_omp = .false.
+  call getin('ok_aie', ok_aie_omp)
 
 !
@@ -128,6 +160,6 @@
 !Config Help = Used in nuage.F
 !
-  bl95_b0 = 2.
-  call getin('bl95_b0', bl95_b0)
+  bl95_b0_omp = 2.
+  call getin('bl95_b0', bl95_b0_omp)
 
 !Config Key  = bl95_b1
@@ -136,6 +168,6 @@
 !Config Help = Used in nuage.F
 !
-  bl95_b1 = 0.2
-  call getin('bl95_b1', bl95_b1)
+  bl95_b1_omp = 0.2
+  call getin('bl95_b1', bl95_b1_omp)
 
 !
@@ -147,6 +179,6 @@
 !               
 !
-  ip_ebil_phy = 0
-  call getin('ip_ebil_phy', ip_ebil_phy)
+  ip_ebil_phy_omp = 0
+  call getin('ip_ebil_phy', ip_ebil_phy_omp)
 !!
 !! Constante solaire & Parametres orbitaux & taux gaz effet de serre BEG
@@ -158,6 +190,6 @@
 !               
 !valeur AMIP II
-  R_ecc = 0.016715
-  call getin('R_ecc', R_ecc)
+  R_ecc_omp = 0.016715
+  call getin('R_ecc', R_ecc_omp)
 !!
 !Config Key  = R_peri
@@ -168,6 +200,6 @@
 !
 !valeur AMIP II
-  R_peri = 102.7
-  call getin('R_peri', R_peri)
+  R_peri_omp = 102.7
+  call getin('R_peri', R_peri_omp)
 !!
 !Config Key  = R_incl
@@ -178,6 +210,6 @@
 !
 !valeur AMIP II
-  R_incl = 23.441
-  call getin('R_incl', R_incl)
+  R_incl_omp = 23.441
+  call getin('R_incl', R_incl_omp)
 !!
 !Config Key  = solaire
@@ -188,6 +220,6 @@
 !
 !valeur AMIP II
-  solaire = 1365.
-  call getin('solaire', solaire)
+  solaire_omp = 1365.
+  call getin('solaire', solaire_omp)
 !!
 !Config Key  = co2_ppm
@@ -198,6 +230,6 @@
 !
 !valeur AMIP II
-  co2_ppm = 348.
-  call getin('co2_ppm', co2_ppm)
+  co2_ppm_omp = 348.
+  call getin('co2_ppm', co2_ppm_omp)
 !!
 !Config Key  = RCO2
@@ -209,5 +241,5 @@
 ! RCO2 = 5.286789092164308E-04
 !ancienne valeur
-  RCO2 = co2_ppm * 1.0e-06  * 44.011/28.97 ! pour co2_ppm=348.
+  RCO2_omp = co2_ppm_omp * 1.0e-06  * 44.011/28.97 ! pour co2_ppm=348.
 
 !!  call getin('RCO2', RCO2)
@@ -228,6 +260,6 @@
   zzz = 1650.
   call getin('CH4_ppb', zzz)
-  CH4_ppb = zzz
-  RCH4 = CH4_ppb * 1.0E-09 * 16.043/28.97
+  CH4_ppb_omp = zzz
+  RCH4_omp = CH4_ppb_omp * 1.0E-09 * 16.043/28.97
 !!
 !Config Key  = RN2O
@@ -246,6 +278,6 @@
   zzz=306.
   call getin('N2O_ppb', zzz)
-  N2O_ppb = zzz
-  RN2O = N2O_ppb * 1.0E-09 * 44.013/28.97
+  N2O_ppb_omp = zzz
+  RN2O_omp = N2O_ppb_omp * 1.0E-09 * 44.013/28.97
 !!
 !Config Key  = RCFC11
@@ -258,6 +290,6 @@
   zzz = 280.
   call getin('CFC11_ppt',zzz)
-  CFC11_ppt = zzz
-  RCFC11=CFC11_ppt* 1.0E-12 * 137.3686/28.97
+  CFC11_ppt_omp = zzz
+  RCFC11_omp=CFC11_ppt_omp* 1.0E-12 * 137.3686/28.97
 ! RCFC11 = 1.327690990680013E-09
 !OK call getin('RCFC11', RCFC11)
@@ -272,6 +304,6 @@
   zzz = 484.
   call getin('CFC12_ppt',zzz)
-  CFC12_ppt = zzz
-  RCFC12 = CFC12_ppt * 1.0E-12 * 120.9140/28.97
+  CFC12_ppt_omp = zzz
+  RCFC12_omp = CFC12_ppt_omp * 1.0E-12 * 120.9140/28.97
 ! RCFC12 = 2.020102726958923E-09
 !OK call getin('RCFC12', RCFC12)
@@ -281,4 +313,13 @@
 !! KE
 !
+
+!Config key  = cvl_corr
+!Config Desc = Facteur multiplication des precip convectives dans KE
+!Config Def  = 1.00
+!Config Help = 1.02 pour un moderne ou un pre-ind. A ajuster pour un glaciaire
+  cvl_corr_omp = 1.00
+  CALL getin('cvl_corr', cvl_corr_omp)
+
+
 !Config Key  = epmax
 !Config Desc = Efficacite precip
@@ -286,6 +327,6 @@
 !Config Help = 
 !
-  epmax = .993
-  call getin('epmax', epmax)
+  epmax_omp = .993
+  call getin('epmax', epmax_omp)
 !
 !Config Key  = ok_adj_ema
@@ -294,6 +335,6 @@
 !Config Help = 
 !
-  ok_adj_ema = .false.
-  call getin('ok_adj_ema',ok_adj_ema)
+  ok_adj_ema_omp = .false.
+  call getin('ok_adj_ema',ok_adj_ema_omp)
 !
 !Config Key  = iflag_clw
@@ -302,6 +343,6 @@
 !Config Help = 
 !
-  iflag_clw = 0
-  call getin('iflag_clw',iflag_clw)
+  iflag_clw_omp = 0
+  call getin('iflag_clw',iflag_clw_omp)
 !
 !Config Key  = cld_lc_lsc 
@@ -310,6 +351,6 @@
 !Config Help = 
 !
-  cld_lc_lsc = 2.6e-4
-  call getin('cld_lc_lsc',cld_lc_lsc)
+  cld_lc_lsc_omp = 2.6e-4
+  call getin('cld_lc_lsc',cld_lc_lsc_omp)
 !
 !Config Key  = cld_lc_con
@@ -318,6 +359,6 @@
 !Config Help = 
 !
-  cld_lc_con = 2.6e-4
-  call getin('cld_lc_con',cld_lc_con)
+  cld_lc_con_omp = 2.6e-4
+  call getin('cld_lc_con',cld_lc_con_omp)
 !
 !Config Key  = cld_tau_lsc
@@ -326,6 +367,6 @@
 !Config Help = 
 !
-  cld_tau_lsc = 3600.
-  call getin('cld_tau_lsc',cld_tau_lsc)
+  cld_tau_lsc_omp = 3600.
+  call getin('cld_tau_lsc',cld_tau_lsc_omp)
 !
 !Config Key  = cld_tau_con
@@ -334,6 +375,6 @@
 !Config Help = 
 !
-  cld_tau_con = 3600.
-  call getin('cld_tau_con',cld_tau_con)
+  cld_tau_con_omp = 3600.
+  call getin('cld_tau_con',cld_tau_con_omp)
 !
 !Config Key  = ffallv_lsc
@@ -342,6 +383,6 @@
 !Config Help = 
 !
-  ffallv_lsc = 1.
-  call getin('ffallv_lsc',ffallv_lsc)
+  ffallv_lsc_omp = 1.
+  call getin('ffallv_lsc',ffallv_lsc_omp)
 !
 !Config Key  = ffallv_con
@@ -350,6 +391,6 @@
 !Config Help = 
 !
-  ffallv_con = 1.
-  call getin('ffallv_con',ffallv_con)
+  ffallv_con_omp = 1.
+  call getin('ffallv_con',ffallv_con_omp)
 !
 !Config Key  = coef_eva
@@ -358,6 +399,6 @@
 !Config Help = 
 !
-  coef_eva = 2.e-5
-  call getin('coef_eva',coef_eva)
+  coef_eva_omp = 2.e-5
+  call getin('coef_eva',coef_eva_omp)
 !
 !Config Key  = reevap_ice
@@ -366,6 +407,6 @@
 !Config Help = 
 !
-  reevap_ice = .false.
-  call getin('reevap_ice',reevap_ice)
+  reevap_ice_omp = .false.
+  call getin('reevap_ice',reevap_ice_omp)
 !
 !Config Key  = iflag_cldcon 
@@ -374,6 +415,6 @@
 !Config Help = 
 !
-  iflag_cldcon = 1
-  call getin('iflag_cldcon',iflag_cldcon)
+  iflag_cldcon_omp = 1
+  call getin('iflag_cldcon',iflag_cldcon_omp)
 
 !
@@ -383,6 +424,6 @@
 !Config Help = 
 !
-  iflag_pdf = 0
-  call getin('iflag_pdf',iflag_pdf)
+  iflag_pdf_omp = 0
+  call getin('iflag_pdf',iflag_pdf_omp)
 !
 !Config Key  = fact_cldcon
@@ -391,6 +432,6 @@
 !Config Help = 
 !
-  fact_cldcon = 0.375
-  call getin('fact_cldcon',fact_cldcon)
+  fact_cldcon_omp = 0.375
+  call getin('fact_cldcon',fact_cldcon_omp)
 
 !
@@ -400,6 +441,6 @@
 !Config Help = 
 !
-  facttemps = 1.e-4
-  call getin('facttemps',facttemps)
+  facttemps_omp = 1.e-4
+  call getin('facttemps',facttemps_omp)
 
 !
@@ -409,6 +450,6 @@
 !Config Help = 
 !
-  ok_newmicro = .true.
-  call getin('ok_newmicro',ok_newmicro)
+  ok_newmicro_omp = .true.
+  call getin('ok_newmicro',ok_newmicro_omp)
 !
 !Config Key  = ratqsbas
@@ -417,6 +458,6 @@
 !Config Help = 
 !
-  ratqsbas = 0.01
-  call getin('ratqsbas',ratqsbas)
+  ratqsbas_omp = 0.01
+  call getin('ratqsbas',ratqsbas_omp)
 !
 !Config Key  = ratqshaut
@@ -425,6 +466,6 @@
 !Config Help = 
 !
-  ratqshaut = 0.3
-  call getin('ratqshaut',ratqshaut)
+  ratqshaut_omp = 0.3
+  call getin('ratqshaut',ratqshaut_omp)
 
 !
@@ -434,6 +475,6 @@
 !Config Help = 
 !
-  rad_froid = 35.0
-  call getin('rad_froid',rad_froid)
+  rad_froid_omp = 35.0
+  call getin('rad_froid',rad_froid_omp)
 
 !
@@ -443,6 +484,6 @@
 !Config Help = 
 !
-  rad_chau1 = 13.0
-  call getin('rad_chau1',rad_chau1)
+  rad_chau1_omp = 13.0
+  call getin('rad_chau1',rad_chau1_omp)
 
 !
@@ -452,6 +493,6 @@
 !Config Help = 
 !
-  rad_chau2 = 9.0
-  call getin('rad_chau2',rad_chau2)
+  rad_chau2_omp = 9.0
+  call getin('rad_chau2',rad_chau2_omp)
 
 !
@@ -461,6 +502,6 @@
 !Config Help =
 !
-  top_height = 3
-  call getin('top_height',top_height)
+  top_height_omp = 3
+  call getin('top_height',top_height_omp)
 
 !
@@ -470,6 +511,6 @@
 !Config Help =
 !
-  overlap = 3
-  call getin('overlap',overlap)
+  overlap_omp = 3
+  call getin('overlap',overlap_omp)
 
 
@@ -481,6 +522,6 @@
 !Config Help =
 !
-  cdmmax = 1.3E-3
-  call getin('cdmmax',cdmmax)
+  cdmmax_omp = 1.3E-3
+  call getin('cdmmax',cdmmax_omp)
 
 !
@@ -490,6 +531,6 @@
 !Config Help =
 !
-  cdhmax = 1.1E-3
-  call getin('cdhmax',cdhmax)
+  cdhmax_omp = 1.1E-3
+  call getin('cdhmax',cdhmax_omp)
 
 !261103
@@ -500,6 +541,6 @@
 !Config Help =
 !
-  ksta = 1.0e-10
-  call getin('ksta',ksta)
+  ksta_omp = 1.0e-10
+  call getin('ksta',ksta_omp)
 
 !
@@ -509,6 +550,6 @@
 !Config Help =
 !
-  ksta_ter = 1.0e-10
-  call getin('ksta_ter',ksta_ter)
+  ksta_ter_omp = 1.0e-10
+  call getin('ksta_ter',ksta_ter_omp)
 
 !
@@ -518,6 +559,13 @@
 !Config Help =
 !
-  ok_kzmin = .true.
-  call getin('ok_kzmin',ok_kzmin)
+  ok_kzmin_omp = .true.
+  call getin('ok_kzmin',ok_kzmin_omp)
+
+!Config Key = ok_lic_melt
+!Config Desc = Prise en compte de la fonte de la calotte dans le bilan d'eau
+!Config Def  = .false.
+!Config Help = mettre a .false. pour assurer la conservation en eau
+  ok_lic_melt_omp = .false.
+  call getin('ok_lic_melt', ok_lic_melt_omp)
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -530,6 +578,6 @@
 !Config Help =
 !
-  iflag_pbl = 1
-  call getin('iflag_pbl',iflag_pbl)
+  iflag_pbl_omp = 1
+  call getin('iflag_pbl',iflag_pbl_omp)
 !
 !Config Key  = iflag_thermals
@@ -538,6 +586,6 @@
 !Config Help =
 !
-  iflag_thermals = 0
-  call getin('iflag_thermals',iflag_thermals)
+  iflag_thermals_omp = 0
+  call getin('iflag_thermals',iflag_thermals_omp)
 !
 !
@@ -547,6 +595,6 @@
 !Config Help =
 !
-  nsplit_thermals = 1
-  call getin('nsplit_thermals',nsplit_thermals)
+  nsplit_thermals_omp = 1
+  call getin('nsplit_thermals',nsplit_thermals_omp)
 
 
@@ -558,6 +606,6 @@
 !Config Help =
 !
-  lev_histhf = 1
-  call getin('lev_histhf',lev_histhf)
+  lev_histhf_omp = 1
+  call getin('lev_histhf',lev_histhf_omp)
 
 !
@@ -567,6 +615,6 @@
 !Config Help =
 !
-  lev_histday = 1
-  call getin('lev_histday',lev_histday)
+  lev_histday_omp = 1
+  call getin('lev_histday',lev_histday_omp)
 
 !
@@ -576,8 +624,8 @@
 !Config Help =
 !
-  lev_histmth = 2
-  call getin('lev_histmth',lev_histmth)
-
-!
+  lev_histmth_omp = 2
+  call getin('lev_histmth',lev_histmth_omp)
+
+  !
 !Config Key  = type_run
 !Config Desc =
@@ -585,8 +633,8 @@
 !Config Help =
 !
-  type_run = 'AMIP'
-  call getin('type_run',type_run)
-
-!
+  type_run_omp = 'AMIP'
+  call getin('type_run',type_run_omp)
+
+  !
 !Config Key  = ok_isccp
 !Config Desc =
@@ -595,6 +643,6 @@
 !
 ! ok_isccp = .true.
-  ok_isccp = .false.
-  call getin('ok_isccp',ok_isccp)
+  ok_isccp_omp = .false.
+  call getin('ok_isccp',ok_isccp_omp)
 
 !
@@ -607,6 +655,6 @@
 !Config Help = 
 !
-   lonmin_ins = 100.
-   call getin('lonmin_ins',lonmin_ins)
+   lonmin_ins_omp = 100.
+   call getin('lonmin_ins',lonmin_ins_omp)
 !
 !Config Key  = lonmax_ins
@@ -616,5 +664,5 @@
 !
    lonmax_ins = 130.
-   call getin('lonmax_ins',lonmax_ins)
+   call getin('lonmax_ins',lonmax_ins_omp)
 !
 !Config Key  = latmin_ins
@@ -623,6 +671,6 @@
 !Config Help = 
 !
-   latmin_ins = -20.
-   call getin('latmin_ins',latmin_ins)
+   latmin_ins_omp = -20.
+   call getin('latmin_ins',latmin_ins_omp)
 !
 !Config Key  = latmax_ins
@@ -631,6 +679,6 @@
 !Config Help =
 !
-   latmax_ins = 20.
-   call getin('latmax_ins',latmax_ins)
+   latmax_ins_omp = 20.
+   call getin('latmax_ins',latmax_ins_omp)
 !
 !Config Key  = ecrit_hf
@@ -639,6 +687,6 @@
 !Config Help =
 !
-  ecrit_hf = 1./8.
-  call getin('ecrit_hf',ecrit_hf)
+  ecrit_hf_omp = 1./8.
+  call getin('ecrit_hf',ecrit_hf_omp)
 !
 !Config Key  = ecrit_day
@@ -647,6 +695,6 @@
 !Config Help =
 !
-  ecrit_day = 1.0
-  call getin('ecrit_day',ecrit_day)
+  ecrit_day_omp = 1.0
+  call getin('ecrit_day',ecrit_day_omp)
 !
 !Config Key  = ecrit_mth
@@ -655,6 +703,6 @@
 !Config Help =
 !
-  ecrit_mth = 30.
-  call getin('ecrit_mth',ecrit_mth)
+  ecrit_mth_omp = 30.
+  call getin('ecrit_mth',ecrit_mth_omp)
 !
 !Config Key  = ecrit_tra
@@ -663,6 +711,6 @@
 !Config Help =
 !
-  ecrit_tra = 30.
-  call getin('ecrit_tra',ecrit_tra)
+  ecrit_tra_omp = 30.
+  call getin('ecrit_tra',ecrit_tra_omp)
 !
 !Config Key  = ecrit_reg
@@ -671,6 +719,6 @@
 !Config Help =
 !
-  ecrit_reg = 0.25   !4 fois par jour
-  call getin('ecrit_reg',ecrit_reg)
+  ecrit_reg_omp = 0.25   !4 fois par jour
+  call getin('ecrit_reg',ecrit_reg_omp)
 !
 !
@@ -682,6 +730,86 @@
 !              de glace de mer Observee
 !
-  ok_slab_sicOBS = .true.
-  call getin('ok_slab_sicOBS', ok_slab_sicOBS)
+  ok_slab_sicOBS_omp = .true.
+  call getin('ok_slab_sicOBS', ok_slab_sicOBS_omp)
+
+
+!$OMP END MASTER
+!$OMP BARRIER
+
+    R_ecc = R_ecc_omp
+    R_peri = R_peri_omp
+    R_incl = R_incl_omp
+    solaire = solaire_omp
+    co2_ppm = co2_ppm_omp
+    RCO2 = RCO2_omp
+    CH4_ppb = CH4_ppb_omp
+    RCH4 = RCH4_omp
+    N2O_ppb = N2O_ppb_omp
+    RN2O = RN2O_omp
+    CFC11_ppt = CFC11_ppt_omp
+    RCFC11 = RCFC11_omp
+    CFC12_ppt = CFC12_ppt_omp
+    RCFC12 = RCFC12_omp
+    epmax = epmax_omp
+    ok_adj_ema = ok_adj_ema_omp
+    iflag_clw = iflag_clw_omp
+    cld_lc_lsc = cld_lc_lsc_omp
+    cld_lc_con = cld_lc_con_omp
+    cld_tau_lsc = cld_tau_lsc_omp
+    cld_tau_con = cld_tau_con_omp
+    ffallv_lsc = ffallv_lsc_omp
+    ffallv_con = ffallv_con_omp
+    coef_eva = coef_eva_omp
+    reevap_ice = reevap_ice_omp
+    iflag_pdf = iflag_pdf_omp
+    rad_froid = rad_froid_omp
+    rad_chau1 = rad_chau1_omp
+    rad_chau2 = rad_chau2_omp
+    top_height = top_height_omp
+    overlap = overlap_omp
+    cdmmax = cdmmax_omp
+    cdhmax = cdhmax_omp
+    ksta = ksta_omp
+    ksta_ter = ksta_ter_omp
+    ok_kzmin = ok_kzmin_omp
+    iflag_pbl = iflag_pbl_omp
+    lev_histhf = lev_histhf_omp
+    lev_histday = lev_histday_omp
+    lev_histmth = lev_histmth_omp
+
+    ocean = ocean_omp
+    ok_veget = ok_veget_omp
+    ok_newmicro = ok_newmicro_omp
+    ok_journe = ok_journe_omp
+    ok_mensuel = ok_mensuel_omp
+    ok_instan = ok_instan_omp
+    ok_ade = ok_ade_omp
+    ok_aie = ok_aie_omp
+    bl95_b0 = bl95_b0_omp
+    bl95_b1 = bl95_b1_omp
+    fact_cldcon = fact_cldcon_omp
+    facttemps = facttemps_omp
+    ratqsbas = ratqsbas_omp
+    ratqshaut = ratqshaut_omp
+    iflag_cldcon = iflag_cldcon_omp
+    ip_ebil_phy = ip_ebil_phy_omp
+    iflag_thermals = iflag_thermals_omp
+    nsplit_thermals = nsplit_thermals_omp
+    type_run = type_run_omp
+    ok_isccp = ok_isccp_omp
+    lonmin_ins = lonmin_ins_omp
+    lonmax_ins = lonmax_ins_omp
+    latmin_ins = latmin_ins_omp
+    latmax_ins = latmax_ins_omp
+    ecrit_hf   = ecrit_hf_omp
+    ecrit_day = ecrit_day_omp
+    ecrit_mth = ecrit_mth_omp
+    ecrit_tra = ecrit_tra_omp
+    ecrit_reg = ecrit_reg_omp
+    ok_slab_sicOBS = ok_slab_sicOBS_omp
+    cvl_corr = cvl_corr_omp
+    ok_lic_melt = ok_lic_melt_omp
+
+!$OMP MASTER
 
   write(numout,*)' ##############################################'
@@ -703,4 +831,6 @@
   write(numout,*)' CFC11_ppt=',CFC11_ppt,' RCFC11 =  ',RCFC11
   write(numout,*)' CFC12_ppt=',CFC12_ppt,' RCFC12 =  ',RCFC12
+  write(numout,*)' cvl_corr=', cvl_corr
+  write(numout,*)'ok_lic_melt=', ok_lic_melt
   write(numout,*)' epmax = ', epmax
   write(numout,*)' ok_adj_ema = ', ok_adj_ema
@@ -741,8 +871,11 @@
   write(numout,*)' lonmin lonmax latmin latmax bilKP_ins =',&
  & lonmin_ins, lonmax_ins, latmin_ins, latmax_ins
-  write(numout,*)' ecrit_ hf, day, mth, reg, tra',&
+  write(numout,*)' ecrit_ hf, day, mth, reg',&
  & ecrit_hf, ecrit_day, ecrit_mth, ecrit_reg, ecrit_tra
+
+!$OMP_END_MASTER
+
   return
-
+  
   end subroutine conf_phys
 
@@ -761,4 +894,5 @@
 
   REAL          :: tau_calv
+  REAL,SAVE     :: tau_calv_omp
 
 ! Local
@@ -770,10 +904,18 @@
 !Config Help = 
 !
-  tau_calv = 360.
-  call getin('tau_calv',tau_calv)
-
+  tau_calv_omp = 360.*10.
+!$OMP MASTER
+  call getin('tau_calv',tau_calv_omp)
+!$OMP END MASTER
+!$OMP BARRIER
+
+  tau_calv=tau_calv_omp
+  
+!$OMP MASTER
   write(numout,*)' ##############################################'
   WRITE(numout,*)' Configuration de l''interface atm/surfaces  : '
   WRITE(numout,*)' tau_calv = ',tau_calv
+!$OMP END MASTER
+
   return
 