Index: LMDZ4/branches/LMDZ4_V2_patch/create_make_gcm
===================================================================
--- LMDZ4/branches/LMDZ4_V2_patch/create_make_gcm	(revision 755)
+++ LMDZ4/branches/LMDZ4_V2_patch/create_make_gcm	(revision 757)
@@ -66,4 +66,5 @@
   echo 'L_PHY = -lsxphy$(PHYS) '
   echo 'L_BIBIO    = -lsxbibio'
+  echo 'L_CHIMIE   ='
   echo 'L_ADJNT    ='
 else
@@ -75,4 +76,5 @@
   echo 'L_PHY = -lphy$(PHYS) '
   echo 'L_BIBIO    = -lbibio'
+  echo 'L_CHIMIE   ='
   echo 'L_ADJNT    ='
 fi
@@ -98,12 +100,12 @@
 echo "PROG = code"
 echo
-echo 'main : $(DYN) bibio phys $(OPTION_DEP) '
+echo 'main : $(OPTION_DEP) $(DYN) bibio phys '
 echo '	cd $(LIBO) ; $(RANLIB) lib*.a ; cd $(GCM) ;\'
 echo '	cd $(LOCAL_DIR); \'
 echo '	$(COMPILE90) $(LIBF)/$(DIRMAIN)/$(PROG).F -o $(PROG).o ; \'
 if [ "$CRAY" = '0' ] ; then
-echo '	$(LINK) $(PROG).o -L$(LIBO) $(L_DYN) $(L_ADJNT) $(L_FILTRE) $(L_PHY) $(L_BIBIO) $(L_DYN) $(OPLINK) $(OPTION_LINK) -o $(LOCAL_DIR)/$(PROG).e ; $(RM) $(PROG).o '
+echo '	$(LINK) $(PROG).o -L$(LIBO) $(L_DYN) $(L_ADJNT)  $(L_CHIMIE) $(L_FILTRE) $(L_PHY) $(L_BIBIO) $(L_DYN) $(OPLINK) $(OPTION_LINK) -o $(LOCAL_DIR)/$(PROG).e ; $(RM) $(PROG).o '
 else
-echo '	$(LINK) $(PROG).o -L$(LIBO) $(L_DYN) $(L_ADJNT) $(L_FILTRE) $(L_PHY) $(L_BIBIO) $(OPLINK) $(OPTION_LINK) -o $(LOCAL_DIR)/$(PROG).e ; $(RM) $(PROG).o '
+echo '	$(LINK) $(PROG).o -L$(LIBO) $(L_DYN) $(L_ADJNT)  $(L_CHIMIE) $(L_FILTRE) $(L_PHY) $(L_BIBIO) $(OPLINK) $(OPTION_LINK) -o $(LOCAL_DIR)/$(PROG).e ; $(RM) $(PROG).o '
 fi
 echo
@@ -115,4 +117,6 @@
 echo
 echo 'adjnt : $(LIBO)/libadjnt.a'
+echo
+echo 'chimie : $(LIBO)/libchimie.a'
 echo
 echo '$(FILTRE)3d : $(LIBO)/lib$(FILTRE).a'
@@ -202,5 +206,5 @@
          done
          echo $str1
-	 if [ "$F90" -eq '0' ] ; then
+	 if [ "$F90" -eq '0' -a -f $fili.F ] ; then
            echo '	cd $(LOCAL_DIR); \'
 	   echo '	$(COMPILE) $(LIBF)/'$diri'/'$trufile' ; \'
Index: LMDZ4/branches/LMDZ4_V2_patch/makegcm
===================================================================
--- LMDZ4/branches/LMDZ4_V2_patch/makegcm	(revision 755)
+++ LMDZ4/branches/LMDZ4_V2_patch/makegcm	(revision 757)
@@ -16,4 +16,5 @@
 set couple=false
 set veget=true
+set chimie=false
 set psmile=false
 set parallel=false
@@ -156,4 +157,5 @@
 set adjnt=""
 set opt_dep=""
+set libchimie=""
 
 set optim=""
@@ -245,8 +247,10 @@
    set mod_suffix="mod"
    set mod_loc_dir="./"
+#################
 else if $X6NEC then
+#################
    set optdbl='-dw -Wf\"-A dbl4\"'  
-   set optim90=' -clear -float0 -size_t64 -Ep -DNC_DOUBLE -dw -Wf\"-A dbl4\" -R5 -Wf,"-pvctl loopcnt=40000 fullmsg noassume "'
-   set optimtru90=' -clear -f4 -float0 -size_t64 -Ep -DNC_DOUBLE -dw -Wf\"-A dbl4\" -R2 -R3 -R4 -R5 -Wf,"-pvctl loopcnt=40000 fullmsg noassume"'
+   set optim90=' -clear -float0 -size_t64 -f3 -Ep -DNC_DOUBLE -dw -Wf\"-A dbl4\" -R5 -Wf,"-pvctl loopcnt=40000 fullmsg noassume "'
+   set optimtru90=' -clear -f4 -float0 -f4 -size_t64 -Ep -DNC_DOUBLE -dw -Wf\"-A dbl4\" -R2 -R3 -R4 -R5 -Wf,"-pvctl loopcnt=40000 fullmsg noassume"'
    set optim="$optim90"
    set optimbis=" "
@@ -345,4 +349,7 @@
 -v true|false
            pour selectionner la vegetation (par defaut) ou non
+
+-chimie CH4|CH4_AER|NMHC|NMHC_AER|AER|GES|false
+	   pour selectionner ou non la chimie (par defaut sans)
 
 -g grille  selectionne le type de grille qu'on veut utiliser.
@@ -415,4 +422,7 @@
 	endif
 	shift ; shift ; goto top
+
+     case -chimie
+	set chimie="$2" ; shift ; shift ; goto top
 
      case -parallel
@@ -491,4 +501,33 @@
    endif
 endif
+
+if ( "$chimie" == 'CH4' ) then
+    set optim="$optim -DINCA -DINCA_CH4 "
+    set optim90="$optim"
+else if ( "$chimie" == 'CH4_AER' ) then
+    set optim="$optim -DINCA -DINCA_CH4 -DINCA_AER"
+    set optim90="$optim"
+else if ( "$chimie" == 'NMHC' ) then
+    set optim="$optim -DINCA -DINCA_NMHC "
+    set optim90="$optim"
+else if ( "$chimie" == 'NMHC_AER' ) then
+    set optim="$optim -DINCA -DINCA_NMHC -DINCA_AER"
+    set optim90="$optim"
+else if ( "$chimie" == 'AER' ) then
+    set optim="$optim -DINCA -DINCA_AER"
+    set optim90="$optim"
+else if ("$chimie" == 'GES' ) then
+    set optim="$optim -DINCA" 
+    set optim90="$optim"
+endif
+if ( "$chimie" == 'CH4' || "$chimie" == 'CH4_AER' || "$chimie" == 'NMHC' || "$chimie" == 'NMHC_AER' || "$chimie" == 'AER' || "$chimie" == 'GES' ) then
+    set opt_dep="$opt_dep chimie" 
+    set libchimie="-lchimie"
+    if ( $XNEC || $X6NEC ) then
+      set libchimie="-lsxchimie"
+    endif
+endif
+
+
 
 if ( "$couple" == 'true' ) then
@@ -987,4 +1026,5 @@
 DIM=$dimc \
 L_ADJNT="$adjnt" \
+L_CHIMIE="$libchimie" \
 LOCAL_DIR="$localdir"  \
 F77="$f77" \
@@ -1010,4 +1050,5 @@
 DIM=$dimc \
 L_ADJNT="$adjnt" \
+L_CHIMIE="$libchimie" \
 LOCAL_DIR="$localdir"  \
 F77="$f77" \